import java.util.*;

public class maxofmin {
  public static void main(String[] args) {
    Scanner scanner = new Scanner(System.in);
    int N = scanner.nextInt();
    int V[] = new int[N];
    for(int i=0; i<N; i++) {
      V[i] =  scanner.nextInt();
    }
    solve(N, V);
  }

  public static void solve(int N, int V[]) {
    int solution[] = new int[N]; // Fill solution
    int mins[] = new int[N];
    solution[0] = getMaxAndCopy(V, mins, N);
    
    for(int size = 2; size <= N; size++) {
    	int maxSize = Integer.MIN_VALUE;
    	
    	for(int start = 0; start < N - size + 1; start++) {
    		int min = mins[start];
    		int n = mins[start + 1];
    		if(min > n) min = n;
    		
    		//System.out.println("Start: " + start + "\t" + Arrays.toString(mins) + "\tMin: " + min);
    		mins[start] = min;
    		if(min > maxSize)
    			maxSize = min;
    	}
    	
    	//System.out.println("MaxSize: " + maxSize);
    	solution[size - 1] = maxSize;
    }

    for(int i=0; i<N; i++)
      System.out.print(solution[i] + " ");
  }
  
  public static int getMaxAndCopy(int[] src, int[] dst, int n) {
	  int max = Integer.MIN_VALUE;
	  for(int i = 0; i < n; i++) {
		  int a = src[i];
		  if(a > max)
			  max = a;
		  dst[i] = a;
	  }
	  return max;
  }
  
  /*for(int size = 1; size <= N; size++) {
	int maxSize = Integer.MIN_VALUE;
	
	for(int start = 0; start < N - size + 1; start++) {
		
		int minBlock = Integer.MAX_VALUE;
  	for(int i = 0; i < size; i++) {
  		int n = V[i + start];
  		if(n < minBlock)
  			minBlock = n;
  	}
  	
  	if(minBlock > maxSize)
  		maxSize = minBlock;
	}
	
	solution[size - 1] = maxSize;
}*/

}
