import java.util.*;

public class postfix {
  public static void main(String[] args) {
    Scanner scanner = new Scanner(System.in);
    int N = scanner.nextInt();
    String V[] = new String[N];
    for(int i=0; i<N; i++) {
      V[i] = scanner.next();
    }
    System.out.println(solve(N, V));
  }

  public static int solve(int N, String V[]) {
    ArrayList<Integer> stack = new ArrayList<Integer>();
    
    for(String s : V) {
    	int i = getInt(s);
    	if(i < 0) {
    		int b = pop(stack), a = pop(stack);
        	switch(s) {
	    		case "+": {
	    			stack.add(a + b);
	    			break;
	    		}
	    		case "-": {
	    			stack.add(a - b);
	    			break;
	    		}
	    		case "*": {
	    			stack.add(a * b);
	    			break;
	    		}
	    	}
    	} else {
    		stack.add(i);
    	}
    }
    
    return pop(stack);
  }

  private static int getInt(String s) {
	  return s.matches("^[+,*,-]$") ? -1 : Integer.parseInt(s);
  }
  private static int pop(ArrayList<Integer> stack) {
	  return stack.remove(stack.size() - 1);
  }
}
