#include <stdio.h>
#include <stdlib.h>

void solve(int N, int *V){
  int *solution = (int*)malloc(N*sizeof(int)); // Fill solution[n]
  int maxSize, start, min, n;
  maxSize = -1;
  for(n = 0; n < N; n++){
    if(V[n] > maxSize)
      maxSize = V[n];
  }
  solution[0] = maxSize;
  
  for(int size = 2; size <= N; size++) {
    	maxSize = -1;
    	
    	for(start = 0; start <= (N - size); start++) {
    		min = V[start];
    		n = V[start + 1];
    		if(min > n) min = n;
    		
    		V[start] = min;
    		if(min > maxSize)
    			maxSize = min;
    	}
    	solution[size - 1] = maxSize;
    }

  for(int i=0; i<N; i++) {
    printf("%d ", solution[i]);
  }
  printf("\n");
}

int main(){
  int N;
  int *V;
  scanf("%d",&N);
  V = (int*)malloc(N*sizeof(int));
  for(int i=0; i<N; i++) scanf("%d", &V[i]);
  solve(N, V);
  return 0;
}
